// AK[i (X1) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{

	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[11];
	int i;
	unsigned char id1[] = "ALGARNA      Sys ";

	struct fpos md1[] =
	{
		{ 0x2c, 0x01, 0x0a00 }, // 
		{ 0x2d, 0x09, 0x0a00 }, // 
		{ 0x2f, 0x01, 0x0a00 }, // 
		{ 0x32, 0x01, 0x0a00 }, // 
		{ 0x33, 0x09, 0x0600 }, // 
		{ 0x35, 0x01, 0x0700 }, // 
		{ 0x36, 0x09, 0x0e00 }, // 
		{ 0x45, 0x01, 0x0e00 }, // 
		{ 0x00, 0x00, 0x0000 },	// End of Data
	};

	struct fpos md2[] =
	{
		{ 0x2c, 0x01, 0x0a00 }, // 
		{ 0x2d, 0x09, 0x0a00 }, // 
		{ 0x2f, 0x01, 0x0900 }, // 
		{ 0x30, 0x09, 0x0900 }, // 
		{ 0x32, 0x01, 0x0b00 }, // 
	//	{ 0x35, 0x01, 0x0b00 }, // 
	//	{ 0x36, 0x09, 0x0b00 }, // 
		{ 0x00, 0x00, 0x0000 },	// End of Data
	};

	if (argc != 2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (int d=0; d<numdisk; d++) {
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x01, 0x01, buff, 0x13);
		disk.SetRecordRange(0x01,0x10);
		// ȃf[^̕ŃfBXN𔻒
		if (!memcmp(&buff[1], id1, sizeof(id1)-1))
		{
			printf("SYSTEM DISK F܂.\n");
			// CvO
			fcut("DRIVER", 0x3d, 0x1e, 0x01, 0x01, 0x01, 0x0000, 0x0c00);
			fcut("MUS000",  0x3e, 0x1f, 0x00, 0x01, 0x01, 0x0000, 0x0f00);
		}
		else if (buff[0]==0x01)
		{
			printf("DISK A F܂.\n");
			for (i=0; md1[i].sec; i++)
			{
				sprintf(fname,"MUS1%02d",i);
				fcut(fname, md1[i].trk, md1[i].trk>>1, md1[i].trk&1, md1[i].sec, 0x01, 0x0000, md1[i].size);
			}
		}
		else if (buff[0]==0x02)
		{
			printf("DISK B F܂.\n");
			// ȃf[^̐؂o
			for (i=0; md2[i].sec; i++)
			{
				sprintf(fname,"MUS2%02d",i);
				fcut(fname, md2[i].trk, md2[i].trk>>1, md2[i].trk&1, md2[i].sec, 0x01, 0x0000, md2[i].size);
			}
		}
	}
	return 0;
}

